# -*- encoding: utf-8 -*-
##############################################################################
#    
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.     
#
##############################################################################


from osv import osv, fields
import time
import dateutil
import dateutil.parser
from dateutil.relativedelta import relativedelta
from datetime import datetime, date
from tools.translate import _
from tools import DEFAULT_SERVER_DATE_FORMAT, DEFAULT_SERVER_DATETIME_FORMAT, float_compare
import decimal_precision as dp
import netsvc
import openerp
import calendar
from openerp import SUPERUSER_ID
import pytz

class purchase_order_line(osv.osv):
    _name = 'purchase.order.line'
    _inherit = 'purchase.order.line'
    _columns = {
    'invoiced_control': fields.boolean('Control de Facturacion'),
    'invoiced_mark': fields.boolean('Facturado'),
    }


    _defaults = {
    }


    def copy_data(self, cr, uid, id, default=None, context=None):
        if not default:
            default = {}
        default.update({
            'invoiced_control': False,
            'invoiced_mark': False,
            })
        return super(purchase_order_line, self).copy_data(cr, uid, id, default, context=context)


purchase_order_line()

class purchase_order(osv.osv):
    _name = 'purchase.order'
    _inherit ='purchase.order'
    _columns = {
    'invoiced_mark': fields.boolean('Facturado'),
        }

    _defaults = {
        }

    def action_invoice_create_gruped_product_lines(self, cr, uid, ids, grouped=False, states=['confirmed', 'done', 'exception'], date_inv = False, context=None):
        print "estoy en el metodo de creacion 1 ##############################################"
        self_br = self.browse(cr, uid, ids, context=None)
        order_line_obj = self.pool.get('purchase.order.line')
        picking_obj = self.pool.get('stock.picking')
        purchase_obj = self.pool.get('purchase.order')
        journal_obj = self.pool.get('account.journal')
        invoice_created_ids = []
        del_invoices = []
        preview_invoice_ids = []
        if context:
            if 'groupby_product' in context:
                groupby_product = context['groupby_product']
                invoice_date = context['invoice_date']
                if groupby_product == True:
                    if grouped == True:
                        wf_service = netsvc.LocalService("workflow")

                        cr.execute("""select name from purchase_order_line where invoiced=True
                            and id in %s;""", (tuple(ids),))
                        cr_res = cr.fetchall()
                        validate_list = [str(x[0]) for x in cr_res if x[0]]
                        if validate_list:
                            raise osv.except_osv(
                            _('Error !'),
                            _('Los siguientes Lineas no se pueden Facturar debido a que estan Facturadas.\n %s' % (str(validate_list),)))
                        sale_order_ids = []
                        cr.execute("""
                            select order_id from purchase_order_line where id in %s
                            """, (tuple(ids),))
                        cr_res = cr.fetchall()
                        sale_order_ids = [x[0] for x in cr_res]
                        sale_order_ids = list(set(sale_order_ids))
                        cr.execute("""select partner_id from purchase_order 
                            where id in %s""",(tuple(sale_order_ids),))
                        cr_res = cr.fetchall()
                        partner_ids = [x[0] for x in cr_res]
                        partner_ids = list(set(partner_ids))
                        cr.execute("""
                            select invoice_id from purchase_invoice_rel
                             where purchase_id in %s;
                            """
                            , (tuple(sale_order_ids),))
                        cr_res = cr.fetchall()
                        preview_invoice_ids = [x[0] for x in cr_res if x]
                        for partner in partner_ids:
                            cr.execute("""select pr.currency_id from purchase_order so join product_pricelist pr 
                                on so.pricelist_id = pr.id  where so.id in %s and so.partner_id=%s;""", (tuple(sale_order_ids), partner,))
                            cr_res = cr.fetchall()
                            validate_list = [x[0] for x in cr_res if x[0]]
                            validate_list = list(set(validate_list))
                            if len(validate_list) > 1:
                                raise osv.except_osv(
                                _('Error !'),
                                _('No puedes Facturar pedidos con distintas Monedas.' ))

                            order_ids = self.search(cr, uid,[('partner_id','=',partner),
                                ('id','in',tuple(sale_order_ids))])
                            order = self.browse(cr, uid, order_ids, context=None)[0]
                            origin = []
                                                                                             
                            a = order.partner_id.property_account_payable.id
                            if order.partner_id and order.partner_id.property_payment_term.id:
                                pay_term = order.partner_id.property_payment_term.id
                            else:
                                pay_term = False
                            for so in self.browse(cr, uid, order_ids, context=None):
                                origin.append(str(so.name))

                            journal_ids = journal_obj.search(cr, uid, [('type', '=', 'purchase'), ('company_id', '=', order.company_id.id)], limit=1)
                            #print "journal",journal_ids
                            if not journal_ids:
                                raise osv.except_osv(_('Error!'),
                                    _('Define purchase journal for this company: "%s" (id:%d).') % (order.company_id.name, order.company_id.id))
                            #print "estoy en esta generacion 2"


                            inv = {
                                'name': order.partner_id.ref or order.name,
                                'origin': str(origin).replace(' ','').replace(',',' | ').replace('[','').replace(']','').replace("'",''),
                                'type': 'in_invoice',
                                'reference': order.partner_id.ref,
                                'account_id': a,
                                'partner_id': order.partner_id.id,
                                'currency_id' : order.pricelist_id.currency_id.id,
                                'comment': order.notes,
                                'journal_id': len(journal_ids) and journal_ids[0] or False,
                                'payment_term': pay_term,
                                'fiscal_position': order.fiscal_position.id or order.partner_id.property_account_position.id,
                                'company_id': order.company_id and order.company_id.id or False,
                                'date_invoice': fields.date.today() if invoice_date == False else invoice_date,
                            }
                            inv_id = self.pool.get('account.invoice').create(cr, uid, inv, context=None)
                            invoice_created_ids.append(inv_id)
                            cr.execute("""
                                select product_id from purchase_order_line where id in %s
                                """, (tuple(ids),))
                            cr_res = cr.fetchall()
                            product_ids = [x[0] for x in cr_res if x[0]]
                            product_ids = list(set(product_ids))
                            for product in product_ids:
                                cr.execute("""
                                    select price_unit from purchase_order_line where id in %s
                                    and product_id = %s
                                    """, (tuple(ids), product, ))
                                cr_res = cr.fetchall()
                                prices = [x[0] for x in cr_res if x[0]]
                                prices = list(set(prices))
                                for price in prices:
                                    order_line_ids = order_line_obj.search(cr, uid,
                                        [('product_id','=', product),
                                        ('price_unit','=',price),
                                        ('id','in',tuple(ids))])
                                    if order_line_ids:
                                        cr.execute("""select sum(product_qty) from purchase_order_line 
                                            where id in %s""", (tuple(order_line_ids),))
                                        cr_res = cr.fetchall()
                                        if cr_res and cr_res[0]:
                                            product_uom_qty = cr_res[0][0]
                                        else:
                                            product_uom_qty = 0.0
                                        line_br = order_line_obj.browse(cr, uid, order_line_ids, context=None)[0]
                                        if line_br.product_id:

                                            if line_br.product_id.type == "product":
                                                account_id=line_br.product_id.categ_id.property_stock_account_input_categ.id
                                            else:
                                                account_id=line_br.product_id.categ_id.property_account_expense_categ.id
                                                if line_br.product_id.valuation == "real_time":
                                                    account_id= line_br.product_id.categ_id.property_stock_account_input_categ.id
                                                    
                                            # account_id = line_br.product_id.property_account_expense.id
                                            # if not account_id:
                                            #     account_id = line_br.product_id.categ_id.property_account_expense_categ.id
                                            if not account_id:
                                                raise osv.except_osv(_('Error !'),
                                                        _('No existe Cuenta Definida para el Producto: "%s" (id:%d)') % \
                                                            (line_br.product_id.name, line_br.product_id.id,))
                                        line_vals = {
                                            'name': line_br.name,
                                            'account_id': account_id,
                                            'price_unit': price,
                                            'quantity': product_uom_qty,
                                            'uos_id': line_br.product_uom.id,
                                            'product_id': line_br.product_id.id or False,
                                            'invoice_line_tax_id': [(6, 0, [x.id for x in line_br.taxes_id])],
                                            'account_analytic_id': line_br.account_analytic_id.id or False,
                                            'invoice_id': inv_id,
                                            }
                                        line_created = self.pool.get('account.invoice.line').create(cr, uid, line_vals, context=None)
                                        order_line_obj.write(cr, uid, order_line_ids, 
                                            {'invoice_lines': [(4, line_created)],'invoiced': True}, context=context) 

                            for o in order_ids:
                                cr.execute('insert into purchase_invoice_rel (purchase_id,invoice_id) values (%s,%s)', (o, inv_id))
                            for p_order in order_ids:
                                o = self.browse(cr, uid, p_order, context=None)
                                if o.invoice_method == 'picking':
                                    picking_obj.write(cr, uid, map(lambda x: x.id, o.picking_ids), {'invoice_state': 'invoiced'})
                                self.write(cr, uid, [p_order], {'state': 'approved'})
                                wf_service.trg_validate(uid, 'purchase.order', p_order, 'manual_invoice', cr)
                                wf_service.trg_validate(uid, 'purchase.order', p_order, 'invoice_corrected', cr)
                            
                            cr.execute("""
                                select invoice_id from purchase_invoice_rel
                                 where purchase_id in %s and invoice_id not in %s;
                                """
                                , (tuple(sale_order_ids), tuple(invoice_created_ids+preview_invoice_ids)))
                            cr_res = cr.fetchall()
                            del_invoices = [x[0] for x in cr_res if x]
                            if del_invoices:
                                self.pool.get('account.invoice').unlink(cr, uid, del_invoices, context)
                        if invoice_created_ids:
                            for invoice in invoice_created_ids:
                                self.pool.get('account.invoice').button_reset_taxes(cr, uid, [invoice], context=context)
                            return invoice_created_ids
        return True

    def action_invoice_create_gruped_product(self, cr, uid, ids, grouped=False, states=['confirmed', 'done', 'exception'], date_inv = False, context=None):
        print "estoy en el metodo de creacion 2 ##############################################"
        journal_obj = self.pool.get('account.journal')
        self_br = self.browse(cr, uid, ids, context=None)
        order_line_obj = self.pool.get('purchase.order.line')
        picking_obj = self.pool.get('stock.picking')
        invoice_created_ids = []
        if context:
            if 'groupby_product' in context:
                groupby_product = context['groupby_product']
                invoice_date = context['invoice_date']
                if groupby_product == True:
                    if grouped == True:
                        wf_service = netsvc.LocalService("workflow")

                        cr.execute("""select name from purchase_order where state not in ('approved','manual')
                            and id in %s;""", (tuple(ids),))
                        cr_res = cr.fetchall()
                        validate_list = [str(x[0]) for x in cr_res if x[0]]
                        if validate_list:
                            raise osv.except_osv(
                            _('Error !'),
                            _('Los siguientes pedidos no se pueden Facturar debido al Estado del registro.\n %s' % (str(validate_list),)))
                        
                        cr.execute("""select name from purchase_order where invoiced_mark=True and id in %s;""", (tuple(ids),))
                        cr_res = cr.fetchall()
                        validate_list = [str(x[0]) for x in cr_res if x[0]]
                        if validate_list:
                            raise osv.except_osv(
                            _('Error !'),
                            _('Los siguientes pedidos ya fueron Facturados.\n %s' % (str(validate_list),)))

                        address_invoice_id = False
                        cr.execute("""select partner_id from purchase_order 
                            where id in %s""",(tuple(ids),))
                        cr_res = cr.fetchall()
                        partner_ids = [x[0] for x in cr_res]
                        partner_ids = list(set(partner_ids))
                        for partner in partner_ids:
                            cr.execute("""select pr.currency_id from purchase_order so join product_pricelist pr 
                                on so.pricelist_id = pr.id  where so.id in %s;""", (tuple(ids),))
                            cr_res = cr.fetchall()
                            validate_list = [x[0] for x in cr_res if x[0]]
                            validate_list = list(set(validate_list))
                            if len(validate_list) > 1:
                                raise osv.except_osv(
                                _('Error !'),
                                _('No puedes Facturar pedidos con distintas Monedas.' ))
                            

                            order_ids = self.search(cr, uid,[('partner_id','=',partner),
                                ('id','in',tuple(ids))])
                            order = self.browse(cr, uid, order_ids, context=None)[0]
                            origin = []
                                                                                  
                            a = order.partner_id.property_account_payable.id

                            if order.partner_id and order.partner_id.property_payment_term.id:
                                pay_term = order.partner_id.property_payment_term.id
                            else:
                                pay_term = False
                            for so in self.browse(cr, uid, order_ids, context=None):
                                origin.append(str(so.name))

                            journal_ids = journal_obj.search(cr, uid, [('type', '=', 'purchase'), ('company_id', '=', order.company_id.id)], limit=1)
                            #print "journal",journal_ids
                            if not journal_ids:
                                raise osv.except_osv(_('Error!'),
                                    _('Define purchase journal for this company: "%s" (id:%d).') % (order.company_id.name, order.company_id.id))
                            #print "estoy en esta generacion"


                            inv = {
                                'name': order.partner_id.ref or order.name,
                                'origin': str(origin).replace(' ','').replace(',',' | ').replace('[','').replace(']','').replace("'",''),
                                'type': 'in_invoice',
                                'reference': order.partner_id.ref,
                                'account_id': a,
                                'partner_id': order.partner_id.id,
                                'currency_id' : order.pricelist_id.currency_id.id,
                                'comment': order.notes,
                                'journal_id': len(journal_ids) and journal_ids[0] or False,
                                'payment_term': pay_term,
                                'fiscal_position': order.fiscal_position.id or order.partner_id.property_account_position.id,
                                'company_id': order.company_id and order.company_id.id or False,
                                'date_invoice': fields.date.today() if invoice_date == False else invoice_date,
                            }

                            inv_id = self.pool.get('account.invoice').create(cr, uid, inv, context=None)
                            invoice_created_ids.append(inv_id)
                            cr.execute("""
                                select product_id from purchase_order_line where order_id in %s
                                """, (tuple(order_ids),))
                            cr_res = cr.fetchall()
                            product_ids = [x[0] for x in cr_res if x[0]]
                            product_ids = list(set(product_ids))
                            for product in product_ids:
                                cr.execute("""
                                    select price_unit from purchase_order_line where order_id in %s
                                    and product_id = %s
                                    """, (tuple(order_ids), product, ))
                                cr_res = cr.fetchall()
                                prices = [x[0] for x in cr_res if x[0]]
                                prices = list(set(prices))
                                for price in prices:
                                    order_line_ids = order_line_obj.search(cr, uid,
                                        [('product_id','=', product),
                                        ('price_unit','=',price),
                                        ('order_id','in',tuple(order_ids))])
                                    if order_line_ids:
                                        cr.execute("""select sum(product_qty) from purchase_order_line 
                                            where id in %s""", (tuple(order_line_ids),))
                                        cr_res = cr.fetchall()
                                        if cr_res and cr_res[0]:
                                            product_uom_qty = cr_res[0][0]
                                        else:
                                            product_uom_qty = 0.0
                                        line_br = order_line_obj.browse(cr, uid, order_line_ids, context=None)[0]
                                        if line_br.product_id:
                                            if line_br.product_id.type == "product":
                                                account_id=line_br.product_id.categ_id.property_stock_account_input_categ.id
                                            else:
                                                account_id=line_br.product_id.categ_id.property_account_expense_categ.id
                                                if line_br.product_id.valuation == "real_time":
                                                    account_id= line_br.product_id.categ_id.property_stock_account_input_categ.id
                                            # account_id = line_br.product_id.property_account_expense.id
                                            # if not account_id:
                                            #     account_id = line_br.product_id.categ_id.property_account_expense_categ.id
                                            if not account_id:
                                                raise osv.except_osv(_('Error !'),
                                                        _('No existe Cuenta Definida para el Producto: "%s" (id:%d)') % \
                                                            (line_br.product_id.name, line_br.product_id.id,))

                                        line_vals = {
                                            'name': line_br.name,
                                            'account_id': account_id,
                                            'price_unit': price,
                                            'quantity': product_uom_qty,
                                            'uos_id': line_br.product_uom.id,
                                            'product_id': line_br.product_id.id or False,
                                            'invoice_line_tax_id': [(6, 0, [x.id for x in line_br.taxes_id])],
                                            'account_analytic_id': line_br.account_analytic_id.id or False,
                                            'invoice_id': inv_id,
                                            }

                                        line_created = self.pool.get('account.invoice.line').create(cr, uid, line_vals, context=None)
                                        order_line_obj.write(cr, uid, order_line_ids, 
                                            {'invoice_lines': [(4, line_created)],'invoiced': True}, context=context) 

                            self.write(cr, uid, order_ids, {'invoice_ids': [(4, inv_id)],'invoiced':True, 'invoiced_mark':True}, context=context) 

                            for p_order in order_ids:
                                o = self.browse(cr, uid, p_order, context=None)
                                if o.invoice_method == 'picking':
                                    picking_obj.write(cr, uid, map(lambda x: x.id, o.picking_ids), {'invoice_state': 'invoiced'})
                                self.write(cr, uid, [p_order], {'state': 'approved'})
                                wf_service.trg_validate(uid, 'purchase.order', p_order, 'manual_invoice', cr)
                                wf_service.trg_validate(uid, 'purchase.order', p_order, 'invoice_corrected', cr)
                                
                        if invoice_created_ids:
                            for invoice in invoice_created_ids:
                                self.pool.get('account.invoice').button_reset_taxes(cr, uid, [invoice], context=context)
                            return invoice_created_ids
        order_ids_not_invoice = self.search(cr, uid, [('id','in',tuple(ids)),('invoiced_mark','=',False)])
        res = False
        if order_ids_not_invoice:
            journal_obj = self.pool.get('account.journal')
            inv_obj = self.pool.get('account.invoice')
            inv_line_obj = self.pool.get('account.invoice.line')
            res = False
            uid_company_id = self.pool.get('res.users').browse(cr, uid, uid, context=context).company_id.id
            for order in self.browse(cr, uid, ids, context=context):
                context.pop('force_company', None)
                if order.company_id.id != uid_company_id:
                    context['force_company'] = order.company_id.id
                    order = self.browse(cr, uid, order.id, context=context)
                pay_acc_id = order.partner_id.property_account_payable.id
                journal_ids = journal_obj.search(cr, uid, [('type', '=', 'purchase'), ('company_id', '=', order.company_id.id)], limit=1)
                if not journal_ids:
                    raise osv.except_osv(_('Error!'),
                        _('Define purchase journal for this company: "%s" (id:%d).') % (order.company_id.name, order.company_id.id))
                inv_lines = []
                for po_line in order.order_line:
                    acc_id = self._choose_account_from_po_line(cr, uid, po_line, context=context)
                    inv_line_data = self._prepare_inv_line(cr, uid, acc_id, po_line, context=context)
                    inv_line_id = inv_line_obj.create(cr, uid, inv_line_data, context=context)
                    inv_lines.append(inv_line_id)
                    po_line.write({'invoice_lines': [(4, inv_line_id)]}, context=context)

                inv_data = {
                    'name': order.partner_ref or order.name,
                    'reference': order.partner_ref or order.name,
                    'account_id': pay_acc_id,
                    'type': 'in_invoice',
                    'partner_id': order.partner_id.id,
                    'currency_id': order.pricelist_id.currency_id.id,
                    'journal_id': len(journal_ids) and journal_ids[0] or False,
                    'invoice_line': [(6, 0, inv_lines)],
                    'origin': order.name,
                    'fiscal_position': order.fiscal_position.id or False,
                    'payment_term': order.payment_term_id.id or False,
                    'company_id': order.company_id.id,
                }
                inv_id = inv_obj.create(cr, uid, inv_data, context=context)
                inv_obj.button_compute(cr, uid, [inv_id], context=context, set_total=True)
                order.write({'invoice_ids': [(4, inv_id)]}, context=context)
                res = inv_id
            
        return res

    def copy(self, cr, uid, id, default=None, context=None):
        if not default:
            default = {}
        default.update({
            'invoiced_mark': False,
            })
        return super(purchase_order, self).copy(cr, uid, id, default, context=context)







class purchase_line_invoice(osv.osv_memory):
    _name = "purchase.order.line_invoice"
    _inherit = "purchase.order.line_invoice"
    _columns = {
        'groupby_partner': fields.boolean('Agrupar por Proveedor', help='Si se activa este Campo el Sistema Creara una Factura por Cada Cliente con las Lineas Seleccionadas.', ),
        'groupby_product': fields.boolean('Agrupar Productos', 
            help='Si activa esta opcion se agruparan las lineas de los productos a Facturar.'),
        'journal_id': fields.many2one('account.journal', 'Diario'),
        'period_id': fields.many2one('account.period','Periodo'),
        'invoice_date': fields.datetime('Fecha de Facturacion'),
        }
        
    def _get_date(self, cr, uid, context=None):
        tz_date = False
        date_now = datetime.now().strftime('%Y-%m-%d %H:%M:%S')
        start = datetime.strptime(date_now, "%Y-%m-%d %H:%M:%S")
        user = self.pool.get('res.users').browse(cr, uid, uid, context=None)
        tz = pytz.timezone(user.tz) if user.tz else pytz.utc
        start = pytz.utc.localize(start).astimezone(tz)     
        tz_date = start.strftime("%Y-%m-%d %H:%M:%S")
        return tz_date

    _defaults = {
    'invoice_date': _get_date,
        }

    def makeInvoices(self, cr, uid, ids, context=None):
        print "estoy en el metodo de creacion 3 ##############################################"
        journal_obj = self.pool.get('account.journal')
        self_br = self.browse(cr, uid, ids[0], context=None)
        invoice_create_ids = []
        active_ids = context and context.get('active_ids', False)
        cr.execute("""
            select order_id from purchase_order_line where id in %s ;
            """, (tuple(active_ids),))
        cr_res = cr.fetchall()
        order_rest_ids = [x[0] for x in cr_res]
        order_rest_ids = list(set(order_rest_ids))

        cr.execute("""
            select name from purchase_order where id in %s and invoice_method = 'picking';
            """, (tuple(order_rest_ids),))
        cr_res = cr.fetchall()
        order_name_rest = [str(x[0]) for x in cr_res]
        order_name_rest = list(set(order_name_rest))
        if order_name_rest:
            raise osv.except_osv(
                           _('Error !'),
                           _('No puedes Facturar pedidos a Facturar desde Albaran.\n %s' % str(order_name_rest)))

        #print "group partner",self_br.groupby_partner
        #print "product",self_br.groupby_product
        if self_br.groupby_partner and self_br.groupby_product == False:
            #print "los dos check son falsos"
            invoice_obj = self.pool.get('account.invoice')
            sale_order_obj = self.pool.get('purchase.order')
            invoice_line_obj = self.pool.get('account.invoice.line')
            sale_order_line = self.pool.get('purchase.order.line')
            res_partner_obj = self.pool.get('res.partner')
            active_ids = context and context.get('active_ids', False)
            wf_service = netsvc.LocalService("workflow")

            if context is None: context = {}
            res = False
            invoices = {}
            del_invoices = []
            partner_ids = []
            
            sales_order_line_obj = self.pool.get('purchase.order.line')
            sales_order_obj = self.pool.get('purchase.order')
            wf_service = netsvc.LocalService('workflow')
            
            cr.execute("""select so.partner_id from purchase_order_line as sol 
                            join purchase_order as so on sol.order_id=so.id 
                            where sol.id in %s group by so.partner_id""",(tuple(active_ids),))
            cr_ids = cr.fetchall()
            if cr_ids:
                partner_ids = [x[0] for x in cr_ids]
            if partner_ids:
                for partner in partner_ids:
                    #print "partner----->>>",partner
                    lines_ids = sale_order_line.search(cr, uid, 
                    [('id','in',tuple(active_ids)),('order_id.partner_id','=',partner),
                    ('invoiced','=',False),('state','not in',('draft', 'cancel'))])
                    invoice_created_list = []
                    invoice_lines_created = []
                    if lines_ids:
                        for line in lines_ids:
                            #print "line----------->>>",line
                            inv_line_obj = self.pool.get('account.invoice.line')
                            purchase_line_obj_ = self.pool.get('purchase.order')

                            purchase_line_br = sale_order_line.browse(cr, uid, line, context=None)
                            #print purchase_line_br

                            #print "---->>>",line
                            #invoice_line_id = sales_order_line_obj.invoice_line_create(cr, uid, [line], context)
                            acc_id = purchase_line_obj_._choose_account_from_po_line(cr, uid, purchase_line_br, context=context)
                            inv_line_data = purchase_line_obj_._prepare_inv_line(cr, uid, acc_id, purchase_line_br, context=context)
                            inv_line_id = inv_line_obj.create(cr, uid, inv_line_data, context=context)
                            
                            invoice_lines_created.append(inv_line_id)

                            purchase_line_br.write({'invoice_lines': [(4, inv_line_id)],'invoiced_control':True,'invoiced':True}, context=context)

                            # sales_order_line_obj.write(cr, uid, [line],
                            #     {'invoice_lines': [(4, inv_line_id[0])], 
                            #     'invoiced_control':True ,'invoiced':True}, context) 
                            
                        partner_br = res_partner_obj.browse(cr, uid, partner, context)
                        a = partner_br.property_account_payable.id
                        if partner_br and partner_br.property_payment_term.id:
                            pay_term = partner_br.property_payment_term.id
                        else:
                            pay_term = False
                        

                        cr.execute("""
                            select order_id from purchase_order_line 
                            where id in %s group by order_id""", (tuple(lines_ids),))
                        cr_res = cr.fetchall()
                        order_ids = [x[0] for x in cr_res]
                        cr.execute("""
                            select name from purchase_order 
                            where id in %s group by name""", (tuple(order_ids),))
                        cr_res = cr.fetchall()
                        origin = [str(x[0]) for x in cr_res]
                        order = sale_order_obj.browse(cr, uid, order_ids, context=None)[0]

                        # journal_ids = journal_obj.search(cr, uid, [('type', '=', 'purchase'), ('company_id', '=', order.company_id.id)], limit=1)
                        # print "journal",journal_ids
                        # if not journal_ids:
                        #     raise osv.except_osv(_('Error!'),
                        #         _('Define purchase journal for this company: "%s" (id:%d).') % (order.company_id.name, order.company_id.id))
                        # print "estoy en esta generacion"


                        invoice_vals = {
                        'name': order.partner_id.ref or order.name,
                        'origin': str(origin).replace(' ','').replace(',',' | ').replace('[','').replace(']','').replace("'",''),
                        'type': 'in_invoice',
                        'reference': order.partner_id.ref,
                        'account_id': a,
                        'partner_id': order.partner_id.id,
                        'currency_id' : order.pricelist_id.currency_id.id,
                        'comment': order.notes,
                        'journal_id': self_br.journal_id.id,
                        'payment_term': pay_term,
                        'fiscal_position': order.fiscal_position.id or order.partner_id.property_account_position.id,
                        'company_id': order.company_id and order.company_id.id or False,
                        'date_invoice': fields.date.today(),
                        'invoiced_control': True,
                        }

                        invoice_created = invoice_obj.create(cr, uid, invoice_vals, context=None)
                        invoice_create_ids.append(invoice_created)


                        invoice_obj.button_reset_taxes(cr, uid, [invoice_created], context=context)
                        sale_order_obj.write(cr, uid, order_ids, {'invoice_ids': [(4, invoice_created)]}, context=context) 
                        invoice_line_obj.write(cr, uid, invoice_lines_created,
                            {'invoice_id': invoice_created}, context=None)
                        for ordering in order_ids:
                            wf_service.trg_validate(uid, 'purchase.order', ordering, 'invoice_corrected', cr)
                            wf_service.trg_validate(uid, 'purchase.order', ordering, 'manual_invoice', cr)
                            lines_write_ids = sales_order_line_obj.search(cr, uid,
                            [('invoiced_control','=',False),('order_id','=',ordering)])
                            sales_order_line_obj.write(cr, uid, lines_write_ids,
                                {'invoiced':False, 'invoice_lines':False})
                        for ori in origin:
                            invoice_delete_ids = invoice_obj.search(cr, uid,
                            [('origin','=',ori),('invoiced_control','=',False)])
                            
                            #print "invoice_delete_ids",invoice_delete_ids
                            #invoice_obj.unlink(cr, uid, invoice_delete_ids, context)
                            
                            stock_origin = '%'+ori
                            asn = ""
                            cr.execute("""select asn from stock_picking
                                where origin like '%s'
                                """ % stock_origin)
                            cr_res = cr.fetchall()
                            if cr_res and cr_res[0] and cr_res[0][0] != None:
                                asn = cr_res[0][0]
                            if asn:
                                invoice_obj.write(cr, uid, invoice_create_ids,
                                    {'asn':asn})
                        for ordering in order_ids:
                            wf_service.trg_validate(uid, 'purchase.order', ordering, 'invoice_corrected', cr)
        elif self_br.groupby_partner and self_br.groupby_product == True:

            order_obj = self.pool.get('purchase.order')
            invoice_obj = self.pool.get('account.invoice')
            mod_obj = self.pool.get('ir.model.data')
            act_obj = self.pool.get('ir.actions.act_window')
            newinv = []
            self_br = self.browse(cr, uid, ids, context=None)[0]
            if context is None:
                context = {}
            data = self.read(cr, uid, ids)[0]
            if self_br.groupby_partner == False and self_br.groupby_product == True:
                raise osv.except_osv(
                       _('Error !'),
                       _('No puedes Agrupar por Producto sin agrupar por Cliente.'))
            context.update({'groupby_product':data['groupby_product'],
                'invoice_date':data['invoice_date'] if data['invoice_date'] else False})
            if self_br.groupby_partner == True and self_br.groupby_product == True:
                inv_ids = order_obj.action_invoice_create_gruped_product_lines(cr, uid, context.get(('active_ids'), []), data['groupby_partner'], date_inv = data['invoice_date'], context=context)

                invoice_obj.write(cr, uid, inv_ids, 
                    {'journal_id':self_br.journal_id.id if self_br.journal_id else False,
                    'period_id': self_br.period_id.id if self_br.period_id else False,})
                invoice_create_ids = inv_ids

                if invoice_create_ids:
                    ir_model_data = self.pool.get('ir.model.data')
                    form_res = ir_model_data.get_object_reference(cr, uid, 'account', 'invoice_form')
                    form_id = form_res and form_res[1] or False
                    tree_res = ir_model_data.get_object_reference(cr, uid, 'account', 'invoice_tree')
                    tree_id = tree_res and tree_res[1] or False
                    return {
                        'domain': "[('id','in', ["+','.join(map(str,invoice_create_ids))+"])]",
                        'name': _('Facturas'),
                        'view_type': 'form',
                        'view_mode': 'tree,form',
                        'res_model': 'account.invoice',
                        'view_id': False,
                        'context': "{'type':'in_invoice', 'journal_type': 'purchase'}",
                        'type': 'ir.actions.act_window',
                    }
                else:
                    return {'type': 'ir.actions.act_window_close'}

            order_obj.action_invoice_create_gruped_product(cr, uid, context.get(('active_ids'), []), data['groupby_partner'], date_inv = data['invoice_date'], context=context)
            wf_service = netsvc.LocalService("workflow")
            
            for id in context.get(('active_ids'), []):
                wf_service.trg_validate(uid, 'purchase.order', id, 'manual_invoice', cr)

            for o in order_obj.browse(cr, uid, context.get(('active_ids'), []), context=context):
                for i in o.invoice_ids:
                    newinv.append(i.id)
            invoice_obj.write(cr, uid, newinv, 
                    {'journal_id':self_br.journal_id.id if self_br.journal_id else False,
                    'period_id': self_br.period_id.id if self_br.period_id else False,
                    'date_invoice': self_br.invoice_date if self_br.invoice_date else False})
            
            invoice_create_ids = newinv

        if invoice_create_ids:
            ir_model_data = self.pool.get('ir.model.data')
            form_res = ir_model_data.get_object_reference(cr, uid, 'account', 'invoice_form')
            form_id = form_res and form_res[1] or False
            tree_res = ir_model_data.get_object_reference(cr, uid, 'account', 'invoice_tree')
            tree_id = tree_res and tree_res[1] or False
            return {
                'domain': "[('id','in', ["+','.join(map(str,invoice_create_ids))+"])]",
                'name': _('Facturas'),
                'view_type': 'form',
                'view_mode': 'tree,form',
                'res_model': 'account.invoice',
                'view_id': False,
                'context': "{'type':'in_invoice', 'journal_type': 'purchase'}",
                'type': 'ir.actions.act_window',
            }
        else:
            return {'type': 'ir.actions.act_window_close'}
        return res
purchase_line_invoice()

